# vyos_facts – Get facts about vyos devices

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Collects facts from network devices running the vyos operating system. This module places the facts gathered in the fact tree keyed by the respective resource name. The facts module will always collect a base set of facts from the device and can enable or disable collection of additional facts.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

gather_network_resources
-
added in 2.9

When supplied, this argument will restrict the facts collected to a given subset. Possible values for this argument include all and the resources like interfaces. Can specify a list of values to include a larger subset. Values can also be used with an initial `!` to specify that a specific subset should not be collected. Valid subsets are 'all', 'interfaces', 'l3_interfaces', 'lag_interfaces', 'lldp_global', 'lldp_interfaces'.

gather_subset - | Default: "!config" | When supplied, this argument will restrict the facts collected to a given subset. Possible values for this argument include all, default, config, and neighbors. Can specify a list of values to include a larger subset. Values can also be used with an initial `!` to specify that a specific subset should not be collected.

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli`.
For more information please see the Network Guide.

A dict object containing connection details.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.

## Notes

Note

- Tested against VyOS 1.1.8 (helium).
- This module works with connection `network_cli`. See the VyOS OS Platform Options.
- For more information on using Ansible to manage network devices see the Ansible Network Guide

## Examples

    # Gather all facts
    - vyos_facts:
        gather_subset: all
        gather_network_resources: all

    # collect only the config and default facts
    - vyos_facts:
        gather_subset: config

    # collect everything exception the config
    - vyos_facts:
        gather_subset: "!config"

    # Collect only the interfaces facts
    - vyos_facts:
        gather_subset:
          - '!all'
          - '!min'
        gather_network_resources:
          - interfaces

    # Do not collect interfaces facts
    - vyos_facts:
        gather_network_resources:
          - "!interfaces"

    # Collect interfaces and minimal default facts
    - vyos_facts:
        gather_subset: min
        gather_network_resources: interfaces

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
ansible_net_api string | always | The name of the transport
ansible_net_commits list | when present | The set of available configuration revisions
ansible_net_config string | when config is configured | The running-config from the device
ansible_net_gather_network_resources list | always | The list of fact resource subsets collected from the device
ansible_net_gather_subset list | always | The list of subsets gathered by the module
ansible_net_hostname string | always | The configured system hostname
ansible_net_model string | always | The device model string
ansible_net_neighbors list | when interface is configured | The set of LLDP neighbors
ansible_net_python_version string | always | The Python version Ansible controller is using
ansible_net_serialnum string | always | The serial number of the device
ansible_net_version string | always | The version of the software running

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Nathaniel Case (@qalthos)
- Nilashish Chakraborty (@Nilashishc)
- Rohit Thakur (@rohitthakur2590)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.